' Ibutton beolvas program PICPLC1/8/16 mikrogepre, ds1990 gombra
' PIC16F1937 mikrokontroller
' A gomb fogad egysg adat vezetke a PORTA.0 portra menjen - B1 sorkapocs - a
' fldpontja rtelemszeren egy GND sorkapocsba, s ha van a fogadnak LED-je,
' akkor az a PORTA.1 s PORTA.2 portokra - B2, B3 sorkapocs - menjen.

#CONFIG             
    __config _CONFIG1, _FOSC_INTOSC & _CP_OFF
    __config _CONFIG2, _PLLEN_OFF & _LVP_OFF 
#endCONFIG

    OSCCON = %01101010   ' Belltom 4 megra a bels rajelet

' Akr 14 lb hasznlhat analg bemenetnek, de most mind digitlis legyen:

   ANSELA = %00000000    ' porta mind digitlis
   ANSELB = %00000000    ' portb mind digitlis
   ANSELD = %00000000    ' portd mind digitlis
   ANSELE = %00000000    ' porte mind digitlis
   
    ADCON1 = 7			' A PORTA es a PORTE most digitalis portkent mukodjon
	
   TRISC = %00111100	' A PORTC 2-5 input, a PORTC 0-1 s 6-7 output
   TRISA = %00000000	' A PORTA 0-7  output
   	
					' Megadjuk az LCD vezerlesi parametereit :
	DEFINE LCD_DREG 	PORTD	' Az LCD adatbitek a D porton,
	DEFINE LCD_DBIT 	0	' es az els bit az RD0.
	DEFINE LCD_RSREG 	PORTD	' A register select bit a D porton,
	DEFINE LCD_RSBIT 	4	' az RD4 port.
	DEFINE LCD_EREG 	PORTD	' Az enable bit a D porton,
	DEFINE LCD_EBIT 	5	' az RD5 portra van kiosztva.
	DEFINE LCD_BITS 	4	' A 4 bites zemmodot valasztjuk,
	DEFINE LCD_LINES 	2	' es 2 soros az LCD

 ROM var byte[8] 
 iButton Var PortA.0 ' iButton olvass a PortA.0
 LEDButA Var PortA.1 ' az olvas LED-jt - ha van neki - a PortA.1 -en villogtatjuk
 LEDButB Var PortA.2 ' az olvas LED-jt - ha van neki - a PortA.1 -en villogtatjuk       					
 
main: 	

           ' Felszlitom a ds1990-at, hogy kldje be a sorozatszmt ! 
    OWOUT iButton,1,[$33] ' hexa 33 a ROM kd olvass parancs
    Pause 100
'Kiolvassuk a 8 bjtot. Egy "family cod" ami a DS1990-nl 01 az els, a CRC ellenrz bjt az utols
' kztk a 6 sorozatszm bjt. (Ami r is van nyomva a gomb tokozsra)
OWIN iButton,0,[ROM[0],ROM[1],ROM[2],ROM[3],ROM[4],ROM[5],ROM[6],ROM[7]]
    ' Kirakom az eredmenyt az LCD-re
Lcdout $fe, 1, "FC: ", hex2 ROM[0], " CRC: ",hex2 ROM[7] ' Tpus azonost - family code - s CRC bjt
LCDOUT $fe,$C0,"SN: ",hex2 ROM[6], hex2 ROM[5], hex2 ROM[4], hex2 ROM[3], hex2 ROM[2], hex2 ROM[1] 'a 6 sorszm

Pause 1000                      ' Egy masodperc szunet...
toggle LEDButA                  ' Egy kis LED villogtats
LEDButB = not LEDbutA

toggle portb.6

	Goto main			' Do it forever...
